<?php

namespace App\Http\Middleware;

use Closure;
use Illuminate\Http\Request;

class SystemCheck
{
    /**
     * Handle an incoming request.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \Closure(\Illuminate\Http\Request): (\Illuminate\Http\Response|\Illuminate\Http\RedirectResponse)  $next
     * @return \Illuminate\Http\Response|\Illuminate\Http\RedirectResponse
     */
    public function handle(Request $request, Closure $next)
    {
        if (!$request->hasSession()) {
            abort(500, 'Session not initialized');
        }
        
        // Cek memory usage
        if (memory_get_usage() > 1500 * 1024 * 1024) {
            abort(503, 'System overload');
        }
        
        return $next($request);
    }
}
